/*
   Generated by EX4-TO-MQ4 decompiler V4.0.220.2c []
   Website: http://purebeam.biz
   E-mail : purebeam@gmail.com
*/
#property copyright "Copyright  2008, TradeWays"
#property link      "http://www.tradeways.org"

extern string TicketsList = "ALL";
extern bool UseCloseOneThird = TRUE;
extern int LevelProfit1 = 20;
extern int LevelMoving1 = 1;
extern int LevelProfit2 = 35;
extern int LevelMoving2 = 10;
extern int LevelProfit3 = 55;
extern int LevelMoving3 = 30;
extern int TrailingStop = 30;
extern int TrailingStep = 5;
extern int Slippage = 2;
extern bool ShowComment = TRUE;
extern bool UseSound = TRUE;

string soundName = "expert.wav";
string arrTickets[];

int init() {
   /*
   if (TimeCurrent() > StrToTime("2009.04.20")) 
   {
      Alert("New version available! Download it using re-activated link from Plimus");
      return;
   }
   */
   TicketsList = TicketsList;
   fSplitStrToStr(TicketsList, arrTickets, "/");
   return (0);
}

void deinit() {
   Comment("");
}
//====================================================================================
//                         START
//====================================================================================
void start() {
   double point;
   int digits;
   string strComment = "";
   for (int i = 0; i < OrdersTotal(); i++) 
   {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol()) 
         {
            for (int iTicket = 0; iTicket < ArraySize(arrTickets); iTicket++) 
            {
               if (fStrUCase(arrTickets[iTicket]) == "ALL" || StrToInteger(arrTickets[iTicket]) == OrderTicket()) 
               {
                  
                  ThreeLevelSystemOfOutput();      //   
                  
                  digits = MarketInfo(OrderSymbol(), MODE_DIGITS);
                  point = MarketInfo(OrderSymbol(), MODE_POINT);
                  strComment = strComment + OrderSymbol() + "  Price: " + DoubleToStr(OrderOpenPrice(), digits) 
                               + "  SL = " + DoubleToStr(OrderStopLoss(), digits) + " (" + StopLossInPoint() + ")\n";
               }
            }
         }
      }
   }
   if (ShowComment) Comment(strComment);
}

void ThreeLevelSystemOfOutput() {
   int li_0 = ProfitPosition();
   int li_4 = StopLossInPoint();
   int li_unused_8 = MarketInfo(OrderSymbol(), MODE_SPREAD);
   if (li_0 > LevelProfit1 && li_0 <= LevelProfit2 && li_4 < LevelMoving1) 
   {
      ModifyStopLossInPoint(LevelMoving1);
      if (UseCloseOneThird) CloseOneThird();
   }
   
   if (li_0 > LevelProfit2 && li_0 <= LevelProfit3 && li_4 < LevelMoving2) ModifyStopLossInPoint(LevelMoving2);
   if (li_0 > LevelProfit3 && li_4 < LevelMoving3) ModifyStopLossInPoint(LevelMoving3);
   if (li_0 > LevelMoving3 + TrailingStop + TrailingStep) TrailingPositions();
}
//=======================================================================================
void CloseOneThird() 
{
   bool l_ord_close_0 = FALSE;
   double l_lots_4 = MathCeil(10.0 * (OrderLots() / 3.0)) / 10.0;
   if (l_lots_4 > 0.0) {
      if (OrderType() == OP_BUY) l_ord_close_0 = OrderClose(OrderTicket(), l_lots_4, Bid, Slippage, CLR_NONE);
      if (OrderType() == OP_SELL) l_ord_close_0 = OrderClose(OrderTicket(), l_lots_4, Ask, Slippage, CLR_NONE);
      if (l_ord_close_0 && UseSound) PlaySound(soundName);
   }
}
//=======================================================================================
void TrailingPositions() 
{
   double bid;
   double ask;
   double point = MarketInfo(OrderSymbol(), MODE_POINT);
   
   if (OrderType() == OP_BUY) {
      bid = MarketInfo(OrderSymbol(), MODE_BID);
      if (ND(bid - OrderOpenPrice()) > ND(TrailingStop * point)) {
         if (ND(OrderStopLoss()) < ND(bid - (TrailingStop + TrailingStep - 1) * point)) {
            ModifyStopLoss(bid - TrailingStop * point);
            return;
         }
      }
   }
   if (OrderType() == OP_SELL) {
      ask = MarketInfo(OrderSymbol(), MODE_ASK);
      if (ND(OrderOpenPrice() - ask) > ND(TrailingStop * point))
         if (ND(OrderStopLoss()) > ND(ask + (TrailingStop + TrailingStep - 1) * point) || ND(OrderStopLoss()) == 0.0) ModifyStopLoss(ask + TrailingStop * point);
   }
}
//===========================================================================================

void ModifyStopLoss(double a_price_0) 
{
   int l_bool_8 = OrderModify(OrderTicket(), OrderOpenPrice(), a_price_0, OrderTakeProfit(), 0, CLR_NONE);
   if (l_bool_8 && UseSound) PlaySound(soundName);
}

//===========================================================================================
void ModifyStopLossInPoint(int punktov) 
{
   double newSL = 0;
   double point = MarketInfo(OrderSymbol(), MODE_POINT);
   
   if (OrderType() == OP_BUY)  newSL = OrderOpenPrice() + punktov * point;
   if (OrderType() == OP_SELL) newSL = OrderOpenPrice() - punktov * point;
   
   int resMod = OrderModify(OrderTicket(), OrderOpenPrice(), newSL, OrderTakeProfit(), 0, CLR_NONE);
   if (resMod && UseSound) PlaySound(soundName);
}

int ProfitPosition() 
{
   double bid;
   double ask;
   double point = MarketInfo(OrderSymbol(), MODE_POINT);
   double profit = 0;
   
   if (OrderType() == OP_BUY) {
      bid = MarketInfo(OrderSymbol(), MODE_BID);
      profit = ND0((bid - OrderOpenPrice()) / point); //ND0 -  double      
   }
   if (OrderType() == OP_SELL) {
      ask = MarketInfo(OrderSymbol(), MODE_ASK);
      profit = ND0((OrderOpenPrice() - ask) / point);
   }
   return (MathRound(profit));  //    
}

int StopLossInPoint() 
{
   double point = MarketInfo(OrderSymbol(), MODE_POINT);
   double sl = 0;
   if (OrderType() == OP_BUY)  sl = ND0((OrderStopLoss() - OrderOpenPrice()) / point);
   if (OrderType() == OP_SELL) sl = ND0((OrderOpenPrice() - OrderStopLoss()) / point);
   if (OrderStopLoss() == 0.0) sl = (-OrderOpenPrice()) / point;
   return (MathRound(sl));
}

double ND0(double value) 
{
   return (NormalizeDouble(value, 0));
}

double ND(double ad_0) {
   return (NormalizeDouble(ad_0, Digits));
}

string fStrUCase(string strX) 
{
   int charCode;
   for (int i = 0; i < StringLen(strX); i++) 
   {
      charCode = StringGetChar(strX, i);
      if (charCode > '`' && charCode < '{') strX = StringSetChar(strX, i, charCode - 32);
      else {
         if (charCode > '' && charCode < 256) 
            strX = StringSetChar(strX, i, charCode - 32);
         else
            if (charCode == '') 
            strX = StringSetChar(strX, i, '');
      }
   }
   return (strX);
}

void fSplitStrToStr(string strX, string &asa_8[], string argumentSymbol) 
{
   string ls_20 = "";
   string symbol = "";
   
   ArrayResize(asa_8, 0);
   for (int i = 0; i < StringLen(strX); i++) 
   {
      symbol = StringSubstr(strX, i, 1);
      if (symbol == argumentSymbol) 
      {
         if (StringTrimLeft(StringTrimRight(ls_20)) != "") 
         {
            ArrayResize(asa_8, ArraySize(asa_8) + 1);
            asa_8[ArraySize(asa_8) - 1] = ls_20;
         }
         ls_20 = "";
      } else
         if (symbol != " ") ls_20 = ls_20 + symbol;
   }
   if (StringTrimLeft(StringTrimRight(ls_20)) != "") 
   {
      ArrayResize(asa_8, ArraySize(asa_8) + 1);
      asa_8[ArraySize(asa_8) - 1] = ls_20;
   }
   ArraySize(asa_8);
}